#include <stdio.h>
#include <ctype.h>
#include <dos.h>

#define ROMTABLE (unsigned char far *) 0xF000FA6E
unsigned char far *wtable = ROMTABLE;                /* BIOS character table */
int nrow = 8;

void prbigstr(unsigned char *fstr,          /* echo "big" characters to screen */
              unsigned char ch,
              unsigned char bk,
			  unsigned vmag,
			  unsigned hmag)
{
    int wrow, wcol, wchar;
    unsigned char *tmpstr, hmult, vmult;

    for (wrow = 0 ; wrow < nrow ; wrow++) {        /* loop through each row */
		for( vmult=0; vmult<vmag; ++vmult) {
            tmpstr = fstr;
            while (*tmpstr) {                          /* loop through chars in string */
                if(*tmpstr > 0x7f && wtable == ROMTABLE) {
                    wchar = 0;
                    tmpstr++;
                }
                else
                    wchar = *(wtable+(nrow * *tmpstr++) +wrow);
                for (wcol = 0 ; wcol < 8 ; wcol++) {    /* loop through columns  */
                    wchar <<= 1;
                    if (wchar & 0x100)
						for( hmult=0; hmult<hmag; ++hmult)
                            putchar(ch);
                    else
                        if((*(tmpstr) || wcol != 7))
							for( hmult=0; hmult<hmag; ++hmult)
                                putchar(bk);
                }
            }
            putchar('\n');
        }
    }
}

void prverstr(unsigned char *fstr,   /* echo "big" vertical characters to screen */
              unsigned char ch,
              unsigned char bk,
			  unsigned vmag,
			  unsigned hmag)
{
    int wrow, wcol, wchar;
    unsigned char *tmpstr;
	unsigned hmult, vmult, mask;

	do {								   /* loop thru character string */
		mask = 0x80;
		for( wcol=0; wcol<8; wcol++) {		/* loop thru columns */
			for( vmult=0; vmult<vmag; ++vmult) {
				for (wrow = nrow-1 ; wrow>=0; wrow--) {	/* loop through rows from bottom*/
					if(*fstr > 0x7f && wtable == ROMTABLE) {
                        wchar = 0;
                    }
                    else
						wchar = *(wtable+(nrow * *fstr) +wrow);
					for( hmult=0; hmult<hmag; ++hmult)
						if (wchar & mask)
							putchar(ch);
						 else
							putchar(bk);
				}
            putchar('\n');
			}
		mask >>= 1;
		}
	} while(*(++fstr));
}

void prshrstr(fstr)     /* echo "short" characters to screen */
char *fstr;
{
    int wrow, wcol, wchar, xchar, twchar, txchar;
    unsigned char *tmpstr;

    for (wrow = 0 ; wrow < nrow ; wrow+=2) {        /* loop through each row */
        tmpstr = fstr;
        while (*tmpstr) {                           /* loop through chars in string */
            if(*tmpstr > 0x7f && wtable == ROMTABLE) {
                wchar = 0;
                xchar = 0;
                tmpstr++;
            }
            else {
                wchar = *(wtable+(nrow * *tmpstr) + wrow);
                xchar = *(wtable+(nrow * *tmpstr++) + wrow+1);
            }
            for (wcol = 0 ; wcol < 8 ; wcol++) {    /* loop through columns  */
                wchar <<= 1;
                xchar <<= 1;
                twchar = wchar & 0x100;
                txchar = xchar & 0x100;
                if (twchar == 0x100 && txchar == 0x100)
                    putchar('');
                else if(twchar == 0 && txchar == 0) {
                    if((*(tmpstr) || wcol != 7))
                        putchar(' ');}
                    else if(twchar == 0x100 && txchar == 0)
                        putchar('');
                else
                    putchar('');
            }
        }
        putchar('\n');
    }
}

void prnarstr(fstr) 		/* echo "narrow" characters to screen */
char *fstr;
{
    int wrow, wcol, wchar, tmpchar;
    unsigned char *tmpstr;

    for (wrow = 0 ; wrow < nrow ; wrow++) {        /* loop through each row */
        tmpstr = fstr;
        while (*tmpstr) {                           /* loop through chars in string */
            if(*tmpstr > 0x7f && wtable == ROMTABLE) {
                wchar = 0;
                tmpstr++;
            }
            else
                wchar = *(wtable+(nrow * *tmpstr++) +wrow);
            for (wcol = 0 ; wcol < 8 ; wcol+=2) {   /* loop through columns */
                wchar <<= 2;
                tmpchar = wchar & 0x300;
                if(tmpchar == 0)
                    putchar(' ');
                else if(tmpchar == 0x0100)
                    putchar('');
                else if(tmpchar == 0x0200)
                    putchar('');
                else
                    putchar('');
            }
        }
        putchar('\n');
    }
}

void prpetstr(fstr) 		/* echo "petite" characters to screen */
char *fstr;
{
	int wrow, wcol, wchar, xchar, twchar, txchar;
	unsigned char *tmpstr;

    for (wrow = 0 ; wrow < nrow ; wrow+=2) {        /* loop through each row */
        tmpstr = fstr;
        while (*tmpstr) {                           /* loop through chars in string */
            if(*tmpstr > 0x7f && wtable == ROMTABLE) {
                wchar = 0;
                xchar = 0;
                tmpstr++;
            }
            else {
                wchar = *(wtable+(nrow * *tmpstr) + wrow);
                xchar = *(wtable+(nrow * *tmpstr++) + wrow+1);
            }
			for (wcol = 0 ; wcol < 8 ; wcol+=2) {	/* loop through columns	*/
				wchar <<= 2;
				xchar <<= 2;
				twchar = (wchar & 0x300) >> 8;
				txchar = (xchar & 0x300) >> 6;
				putchar(0xc0+twchar+txchar);
			}
        }
        putchar('\n');
    }
}

unsigned char far *getFontAdr(int which)  /* use a BIOS call to get a font address */
{
_asm {
    push    bp
    mov     ax,0x1130
    mov     bh,which
    int     0x10
    mov     ax,bp
    pop     bp
    mov     dx,es
    }
}

#define EGAVGA_SEQUENCER 0x3c4
#define EGAVGA_GRAPHCTR 0x03ce

void allowFontAccess(void)
{
	int i;
	static unsigned SeqRegs[4] = {0x0100, 0x0402, 0x0704, 0x0300 },
					GCRegs[3] = {0x0204, 0x0005, 0x0006 };

	_disable();
	for( i=0; i<4; ++i)
		outpw(EGAVGA_SEQUENCER,SeqRegs[i]);
	for( i=0; i<3; ++i)
		outpw(EGAVGA_GRAPHCTR,GCRegs[i]);
	_enable();
}
void releaseFontAccess(void)
{
	int i;
	static unsigned SeqRegs[4] = {0x0100, 0x0302, 0x0304, 0x0300 },
					GCRegs[3] = {0x0004, 0x1005, 0x0e06 };

	_disable();
	for( i=0; i<4; ++i)
		outpw(EGAVGA_SEQUENCER,SeqRegs[i]);
	for( i=0; i<3; ++i)
		outpw(EGAVGA_GRAPHCTR,GCRegs[i]);
	_enable();
}
static unsigned char tops[16] = { 0x00 ,0x0f, 0xf0, 0xff, 0x00, 0x0f, 0xf0, 0xff, 0x00, 0x0f, 0xf0, 0xff, 0x00, 0x0f, 0xf0, 0xff };
static unsigned char bots[16] = { 0x00, 0x00, 0x00, 0x00, 0x0f, 0x0f, 0x0f, 0x0f, 0xf0, 0xf0, 0xf0, 0xf0, 0xff, 0xff, 0xff, 0xff };
unsigned char newDraw[16*16];

unsigned char charRows;		/* # of scan lines in current character set */
void loadFont(unsigned char far *ptr)	/* use a BIOS call to define some new character patterns */
{
	unsigned tempSeg, tempOff;
	tempSeg = FP_SEG(ptr);
	tempOff = FP_OFF(ptr);

_asm {
	push bp
	mov ax,tempSeg
	mov es,ax
	mov bp,tempOff
	mov ax,0x1110
	mov cx,0x0010
	mov dx,0x00c0
	mov bl,0
	mov bh,charRows
	int 0x10
	pop bp

	}
}
unsigned char string[100];
unsigned char type='B';
unsigned char character='';
unsigned char background=' ';

main(argc,argv)
int argc;
char *argv[];
{
	int i, j, k, error=0, len;
	unsigned char switchChar, typeChar, array[2], ch;
	unsigned char far *tmpPtr, far *videoPtr=0xA0000000;
	unsigned vmag=1, hmag=1;
	unsigned long far *ptr;
	unsigned long ltmp;
	unsigned char buffer[4096];

    string[0] = 0;

    if(argc < 2)
        error = 1;

    for( i=1; i<argc && !error; ++i) {
        if(argv[i][0] == '/') {
            switchChar = toupper(argv[i][1]);
            if(switchChar == '/') {
				strcat(string,&argv[i][1]); }
            else if(switchChar == 'S') {
                typeChar = toupper(argv[i][2]);
				if(typeChar == 'B' || typeChar == 'N'
					|| typeChar == 'S' || typeChar == 'V' || typeChar == 'P')
                    type = typeChar;
                else
					error = 1;
				if(type == 'P') {
					charRows = *((unsigned char	far *)0x00400085);
					for( k=0; k<16; ++k) {
						for( j=0; j<charRows/2; ++j) {
							newDraw[k*charRows+j] = tops[k];
							newDraw[k*charRows+j+charRows/2] = bots[k];
						}
					}
					loadFont(newDraw);
				}
            }
            else if(switchChar == 'C') {
                if(argv[i][2]) {
                    character = argv[i][2];
                    if(argv[i][3])
                        background = argv[i][3];
                }
                else
                    error = 1;
            }
            else if(switchChar == 'M') {
				if(isdigit(argv[i][2])) {
					array[0] = argv[i][2];
					array[1] = 0;
					hmag = vmag = atoi(array);
					if(argv[i][3]) {
						if(isdigit(argv[i][3])) {
							array[0] = argv[i][3];
							array[1] = 0;
							hmag = atoi(array);
						}
						else
							 error = 1;
					}
                }
                else
                    error = 1;
            }
            else if(switchChar == 'N') {
                if(isdigit(argv[i][2])) {
                    character = atoi(&argv[i][2]);
                    if( character < 1 || character > 254)
                        error = 1;
                }
                else
                    error = 1;
            }
            else if(switchChar == 'F') {
                typeChar = toupper(argv[i][2]);
                if(typeChar == 'C') {
                    wtable = ROMTABLE;
                    nrow = 8; }
                else if(typeChar == 'E') {
                    wtable = getFontAdr(1);
                    nrow = 8; }
                else if(typeChar == '4') {
                    wtable = getFontAdr(2);
                    nrow = 14; }
				else if(typeChar == '6') {
                    wtable = getFontAdr(6);
                    nrow = 16; }
				else if(typeChar == 'S') {
					tmpPtr = 0x00000485;
					nrow = (int) *tmpPtr;
					tmpPtr = (unsigned char *) malloc(4096);
					wtable = tmpPtr;
					allowFontAccess();
					for( j=0; j<256; ++j) {
						for( k=0; k<nrow; ++k)
							*tmpPtr++ = *videoPtr++;
						videoPtr += 32 - nrow;
					}
					releaseFontAccess();
				}
				else if(typeChar == 'A') {
					ptr = 0x000004a8;
					ptr =(unsigned char far *) *ptr;
					ltmp=ptr;
					ltmp+=8;
					ptr = ltmp;
					ptr = (unsigned char far *) *ptr;
					if(ptr) {
						nrow = (int) *ptr;
						ltmp=ptr;
						ltmp+=6;
						ptr = ltmp;
						wtable = (unsigned char far *) *ptr; }
					else {
						fputs("bigtext:  No screen font loaded in Video Save Table.\n",stdout);
						exit();
					}
				}
                else
                   error = 1;
            }
            else
                error = 1;
        }
        else {
			strcat(string,argv[i]);
			strcat(string," ");  }
    }
    if(error) {
		fputs("bigtext 2.0 by luitje@m-net.arbornet.org; translates your text to BIG text.\n\n",stdout);
//		fputs("bigtext, version 2.0 by luitje@m-net.arbornet.org\n",stdout);
//		fputs("Translates your text to BIG text.\n",stdout);
		fputs("Usage:  bigtext [/switch ...] text ...\n",stdout);
        fputs("   where switches may be:\n",stdout);
		fputs("     /Sx specifies character Style\n",stdout);
		fputs("         where x is B for Big characters (default)\n",stdout);
		fputs("                    N for Narrow characters\n",stdout);
		fputs("                    S for Short characters\n",stdout);
		fputs("                    P for Petite characters\n",stdout);
		fputs("                    V for Vertical big characters\n",stdout);
		fputs("     /Fx specifies character Font\n",stdout);
		fputs("         where x is C for CGA 8x8 font (default)\n",stdout);
		fputs("                    E for E/VGA 8x8 font\n",stdout);
		fputs("                    4 for E/VGA 8x14 font\n",stdout);
		fputs("                    6 for VGA 8x16 font\n",stdout);
		fputs("                    S for E/VGA current Screen font\n",stdout);
		fputs("                    A for Alternate character font\n",stdout);
		fputs("     /Mn[m] specifies Magnification for big & vertical styles\n",stdout);
		fputs("            where n specifies vertical magnification (default is 1)\n",stdout);
		fputs("                  m specifies horizontal magnification (default is 1)\n",stdout);
		fputs("     /Cx[y] specifies the Characters to use for big & vertical styles\n",stdout);
		fputs("            where x is the foreground character (default '')\n",stdout);
		fputs("                  y, if given, is the background character (default blank)\n",stdout);
		fputs("     /Nn specifies the foreground character for big style Numerically (def '')\n",stdout);
		fputs("Press ESC to exit help; any other character for the second page.",stdout);
		ch = getch();
		fputs("\r                                                                \r",stdout);
		if(ch != 0x1b) {
			fputs("         where 'n' is the decimal character number from 1 to 254 \n",stdout);
			fputs("   and 'text' is what you want echoed.\n",stdout);
			fputs("Notes:\n",stdout);
			fputs(" When the output is made to the screen, the BIOS will wrap it at 80 columns\n",stdout);
			fputs("  which may break up the character patterns if your text is too long.\n",stdout);
			fputs(" The switches must be separated by spaces.\n",stdout);
			fputs(" To use '/' as the first character in a phrase, use '//'.\n",stdout);
			fputs(" The output is done to stdout; hence it can be redirected to a file. Some\n",stdout);
			fputs("  characters can't be displayed because they have special meaning to MS-DOS,\n",stdout);
			fputs("  or stdout filters them out or they don't have displayable symbols.\n",stdout);
			fputs(" /C, /N and /M can not be used with /SN, /SS or /SP.\n",stdout);
			fputs(" The /FC font can't display characters greater than 127 (DEL).\n",stdout);
			fputs(" The magnification parameters, n and m, are limited to the range 1-9.\n",stdout);
			fputs("  If you specify n but not m, then m is set to n by default.\n",stdout);
			fputs(" No check is made for the presence of an EGA or VGA card when using the E, 4,\n",stdout);
			fputs("  6, or A fonts. You will get random patterns if you don't have the right card.\n",stdout);
			fputs(" /FA fonts must be installed before use.\n",stdout);
			fputs(" Some useful characters are '' = 176, '' = 177, '' = 178 and '' = 223.\n",stdout);
			fputs("\nExample:  bigtext /ss Hello!\n",stdout);
            fputs("                                 \n",stdout);
            fputs("                    \n",stdout);
            fputs("                         \n",stdout);
			fputs("                        ",stdout);
        }
    }
    else {
        len = strlen(string) - 1;
        if(string[len] == ' ')
            string[len] = '\0';
//		printf("Type = %c, Font = %c, Character = %c, String = '%s', Nrow=%d,%08lx\n",type,typeChar,character,string,nrow,wtable);
        if(type == 'B')
			prbigstr(string,character,background,vmag,hmag);
        else if(type == 'S')
            prshrstr(string);
		else if(type == 'N')
			prnarstr(string);
		else if(type == 'P')
			prpetstr(string);
		else
			prverstr(string,character,background,vmag,hmag);
		if(tmpPtr)
			free(tmpPtr);
	}
}
